#!/usr/bin/perl -w
#
# *****************************************
# Manipulation des vhosts/Auth lighttpd
# par Nico <nico@gcu.info>
# *****************************************

use strict;
use Net::LDAP;

my $mesg;
my $ldap;

my $ldap_server="";
my $ldap_binddn="";
my $ldap_bindpw="";
my $ldap_basedn="";

sub ldap_connect {
        $ldap = Net::LDAP->new($ldap_server)
        or die "erreur LDAP: ne peut binder au serveur ($@)";

        $mesg = $ldap->bind( $ldap_binddn, password => $ldap_bindpw );
        $mesg->code && die $mesg->error;
}

sub confreader {
	$mesg = $ldap->search(
		base	=> $ldap_basedn,
		scope 	=> 'sub',
		filter	=> '(lighttpdServerName=*)'
	);

	$mesg->code && die $mesg->error;
	foreach my $entry ($mesg->all_entries) {
		print "\$HTTP[\"host\"] == \"".$entry->get_value("lighttpdServerName")."\" \{\n";
		print "		server.document-root = \"".$entry->get_value("lighttpdDocumentRoot")."\"\n";
		if($entry->get_value("lighttpdAuthBackend"))
		{
			print "		auth.backend = \"".$entry->get_value("lighttpdAuthBackend")."\"\n";
			# choose your authentication
			if ($entry->get_value("lighttpdAuthBackend") eq "ldap")
			{
				# not yet, coming later
				print "		auth.backend.ldap.hostname = \"".$entry->get_value("lighttpdAuthLDAPHostname")."\"\n";
				print "		auth.backend.ldap.base-dn = \"lighttpdServerName=".$entry->get_value("lighttpdServerName").",".$entry->get_value("lighttpdAuthLDAPBaseDN")."\"\n";
				print "		auth.backend.ldap.filter = \"".$entry->get_value("lighttpdAuthLDAPFilter")."\"\n";
				if ($entry->get_value("lighttpdAuthLDAPStartTLS") eq "enable")
				{
					print "		auth.backend.ldap.starttls = \"".$entry->get_value("lighttpdAuthLDAPStartTLS")."\"\n";
					print "		auth.backend.ldap.ca-file = \"".$entry->get_value("lighttpdAuthLDAPCAFile")."\"\n";
				}
				print "		auth.backend.ldap.bind-dn = \"".$entry->get_value("lighttpdAuthLDAPBindDN")."\"\n";
				print "		auth.backend.ldap.bind-pw = \"".$entry->get_value("lighttpdAuthLDAPBindPW")."\"\n";
				# require password by default
				if ($entry->get_value("lighttpdAuthLDAPStartTLS") eq "1")
				{
					print "		auth.backend.ldap.allow-empty-pw = \"".$entry->get_value("lighttpdAuthLDAPAllowEmptyPW")."\"\n";
				}
			}
			else
			{
				print "		auth.backend.".$entry->get_value("lighttpdAuthBackend").".userfile= \"".$entry->get_value("lighttpdAuthUserFile")."\"\n";
			}
			# end of choice
			print "		# Authentication is required for this vhost\n";
			print "		auth.require = ( \"".$entry->get_value("lighttpdAuthPath")."\" =>\n";
			print "				(\n";
			# as digest method is incomplete, it is not implemented here.
			# see http://trac.lighttpd.net/trac/wiki/Docs%3AModAuth
			print "			\"method\"  => \"basic\",\n";
			print "			\"realm\"  => \"".$entry->get_value("lighttpdAuthRealm")."\",\n";
			print "			\"require\"  => \"".$entry->get_value("lighttpdAuthRequire")."\"\n";
			print "			)\n";
			print "		)\n";
			print "		# End of authentication config\n";
		}
		else
		{
			print "		# No authentication required for this vhost\n";
		}
		
		print "\}\n\n";
		


	}
}

&ldap_connect;

&confreader();

$ldap->unbind();
